package projects.abp.nodes.nodeImplementations;

import java.awt.Color;
import java.awt.Graphics;
import java.util.Iterator;
import java.util.*;
import projects.abp.nodes.messages.DATA;
import projects.abp.nodes.messages.Ack;
import projects.abp.nodes.timers.initTimer;
import projects.abp.nodes.timers.Minuteur;


import sinalgo.configuration.WrongConfigurationException;
import sinalgo.gui.transformation.PositionTransformation;
import sinalgo.nodes.Node;
import sinalgo.nodes.edges.Edge;
import sinalgo.nodes.messages.Inbox;
import sinalgo.nodes.messages.Message;
import sinalgo.tools.Tools;



public class abpNode extends Node {
	
    // Entrée
    Queue<String> Depart = new LinkedList<String>();
    
    // Sortie
    Queue<String> Arrivee = new LinkedList<String>();    
	
    // Variables
    int Tag;
    String Buffer;
    
    boolean Emetteur(){
	return this.ID == 1;
    }
	
    boolean Recepteur(){
	return this.ID != 1;
    }
	
    void inverseTag(){
	this.Tag=(this.Tag+1)%2;
    }
    
    public void preStep() {}
    
    // ATTENTION lorsque init est appelé les liens de communications n'existent pas
    // il faut attendre une unité de temps, avant que les connections soient ralises
    // nous utilisons donc un timer
	
    public void init() {
	(new initTimer()).startRelative(1, this);
	
	// Initialisation de la file de Départ avec 10 messages à envoyer
	if(Emetteur()){
	    for(int i =1; i<=10;i++)
		Depart.add("Hello " + i);
	}
	
    }
	
	
    Node getVoisin(){
	Iterator<Edge> iter=this.outgoingConnections.iterator();
	return iter.next().endNode;
    }
	
	
    // Lorsque le timer précédent expire, la fonction start est
    // appelée elle correspond ainsi à l'initialisation REELLE du
    // processus

    public void start(){    
	if(this.Emetteur()) {
	    this.Tag=0;
	    this.Buffer=null;
	    Minuteur M=new Minuteur();
	    M.startRelative(10, this);
	}	
	else{
	    this.Tag=0;
	    this.Arrivee.clear();
	}
    }
	
    void AfficheArrivee(){
	for(String s : this.Arrivee)
	    System.out.println(s);
    }
	
    // expiration_timer contient le contenu de la boucle pour
    // l'émetteur sauf le traitement des messages
    
    public void expiration_timer(){
	if(this.Buffer == null){
	    if(!this.Depart.isEmpty()){
		this.Buffer=this.Depart.poll();
		this.inverseTag();
	    }
	    else{
		// si la file départ est vide, on arrête la simulation
		Tools.stopSimulation();
	    }
	}
	if(this.Buffer != null){
	    this.send(new DATA(this.Tag,this.Buffer),this.getVoisin());
	}
	Minuteur M=new Minuteur();
	M.startRelative(10, this);		
    }

	// Cette fonction gère la réception de message Elle est
	// appelée régulièrement même si aucun message n'a été reçu
	
    public void handleMessages(Inbox inbox) {
	// Test si il y a des messages
	while(inbox.hasNext()){
	    Message m=inbox.next();
	
	    if(m instanceof DATA){
		DATA msg=(DATA) m;
		// A COMPLETER
		}
	
	    if(m instanceof Ack){		
		Ack msg=(Ack) m;
		// A COMPLETER	
	    }
	}	
    }	
	
    public void neighborhoodChange() {}
    public void postStep() {}
    public void checkRequirements() throws WrongConfigurationException {}
	
    public Color Couleur(){
	if(this.Tag==1) return Color.red;
	return Color.blue;
    }
	
    // affichage du noeud
	
    public void draw(Graphics g, PositionTransformation pt, boolean highlight){
	this.setColor(this.Couleur());
	String text = ""+this.ID;
	super.drawNodeAsDiskWithText(g, pt, highlight, text, 20, Color.black);
    }
	
}
